#!/bin/sh
# HS3 Patch collection

DIR_IMAGE="image" 								# Progress bar frames showed during FW Carrier upgrade
DIR_ZONEINFO="/usr/share/zoneinfo"						# Timezone details
FILE_FBV="/usr/bin/fbv"								# Image player application
DIR_DOWNLOAD="download"								# Download folder for runtime upgrade
FILE_MOD_WF111="/lib/modules/3.0.35-2666-gbdde708/extra/unifi_sdio.ko"		# Wifi module
FILE_HWCLOCK="/sbin/hwclock"
DIR_CUSTOM="custom"								# Custom folder for wav files
DIR_MOD_MISC="/lib/modules/3.0.35-2666-gbdde708/misc"				# Kernel module misc folder for module
DIR_TVCC="tvcc" 								# TVCC folder 
FILE_STARTUP="/home/user/startup.sh"						# Video player application
DIR_DATA_CATALOG="data/catalog"							# Catalog folder
DIR_CUSTOM_AUDIO_WAV="custom/audio/wav"						# Custom audio wav folder
DIR_DATA_BRAND="data/sil"							# Old data brand folder
DIR_CUSTOM_BRAND="custom/sil"							# Old custom brand folder
DIR_DOWNLOAD_CLOUD="download/cloud"						# dhcpd-reservations.conf
FILE_DHCPD_RESERVATIONS="/etc/dhcpd-reservations.conf"
FILE_HS3_GPIO_MOD="/lib/modules/3.0.35-2666-gbdde708/misc/hs3_gpio_mod.ko"
FILE_WPA_CLI_WPS="/usr/local/bin/wpa_cli_wps"					# wpa_cli with WPS application
FILE_WPA_PASSPHRASE_WPS="/usr/local/bin/wpa_passphrase_wps"			# wpa_passphrase with WPS application
FILE_WPA_SUPPLICANT_WPS="/usr/local/bin/wpa_supplicant_wps"			# wpa_supplicant with WPS application
FILE_SSH_44P1="/usr/bin/ssh_44p1"						# upgrade openssh to ver 4.4P1
FILE_SCREEN_402="/usr/bin/screen"						# add screen 4.0.2
FILE_VER_CARRIER_SET="/home/user/new/ver_carrier_set.sh"			# patch per impostare la versione carrier su ver.txt da APP
FILE_PPPD="/sbin/pppd"								# PPP utilities
FILE_PPP_IP_UP="/etc/ppp/ip-up"							# aggiornamento folder PPP
FILE_MODEXAMPLE="/lib/modules/3.0.35-2666-gbdde708/misc/modexample.ko"		# Kernel module misc folder for module
FILE_U_BLOX_V00="/lib/modules/3.0.35-2666-gbdde708/extra/nxp/v00.txt"		# Kernel module u-blox version 00.00
FILE_HOSTAPD="/usr/local/bin/hostapd"
FILE_MLANUTL="/home/user/new/mlanutl"						# U-BLOX utility (currently used to set countrycode)
FILE_MOD_NET_USB_ASIX="/lib/modules/3.0.35-2666-gbdde708/kernel/drivers/net/usb/asix.ko"	# driver module net usb asix
DIR_MOD_NET_USB="/lib/modules/3.0.35-2666-gbdde708/kernel/drivers/net/usb"	# Kernel module net usb folder
DIR_MOD="/lib/modules/3.0.35-2666-gbdde708"					# Kernel module folder


if [ -d $DIR_IMAGE ]; then
	echo "folder image present"
	if diff /home/user/new/image/FW_upd_00.png upgrade/tmp/image/FW_upd_00.png >/dev/null ; then
		echo "image OK"
	else
		cp -f upgrade/tmp/image/*.png /home/user/new/image
	fi
else
	cp -r upgrade/tmp/image .
fi
if [ -d $DIR_ZONEINFO ]; then
	echo "folder zoneinfo present"
else
	cp -r upgrade/tmp/zoneinfo /usr/share
	cp -r upgrade/tmp/zoneinfo-leaps /usr/share
	cp -r upgrade/tmp/zoneinfo-posix /usr/share
fi
if [ -f $FILE_FBV ]; then
	echo "file fbv present"
else
	cp upgrade/tmp/fbv /usr/bin
fi
if [ -d $DIR_DOWNLOAD ]; then
	echo "folder download present"
else
	mkdir /home/user/new/download
	rm -f /home/user/upgrade/*
	cp -f upgrade/tmp/dhcpd.conf /etc
	cp -f upgrade/tmp/dhcpd-reservations.conf /etc
	cp -f upgrade/tmp/httpd.conf /usr/conf
fi
if diff $FILE_MOD_WF111 upgrade/tmp/mod_wf111_5.2.2/unifi_sdio.ko >/dev/null ; then
	echo "MOD WF111 OK"
else
	rmmod -f unifi_sdio
	cp -f upgrade/tmp/mod_wf111_5.2.2/unifi_sdio.ko $FILE_MOD_WF111
	cp -f upgrade/tmp/mod_wf111_5.2.2/unififw /usr/sbin
	cp -f upgrade/tmp/mod_wf111_5.2.2/unifi_config /usr/sbin
	cp -f upgrade/tmp/mod_wf111_5.2.2/unifi_helper /usr/sbin
	cp -f -r upgrade/tmp/mod_wf111_5.2.2/unifi-sdio /lib/firmware
	rm -f -r /lib/firmware/unifi-sdio-0
	rm -f -r /lib/firmware/unifi-sdio-1
	rm -f -r /lib/firmware/unifi-sdio-2
	rm -f -r /lib/firmware/unifi-sdio-3
	modprobe unifi_sdio
fi
if diff $FILE_HWCLOCK upgrade/tmp/hwclock >/dev/null ; then
	echo "HWCLOCK OK"
else
	cp -f upgrade/tmp/hwclock /sbin
fi
if [ -d $DIR_CUSTOM ]; then
	echo "folder custom present"
else
	mkdir /home/user/new/custom
	mkdir /home/user/new/custom/sil
	mkdir /home/user/new/custom/sil/audio
	mkdir /home/user/new/custom/sil/audio/wav
	mkdir /home/user/new/custom/nice
	mkdir /home/user/new/custom/nice/audio
	mkdir /home/user/new/custom/nice/audio/wav
	mkdir /home/user/new/custom/diy
	mkdir /home/user/new/custom/diy/audio
	mkdir /home/user/new/custom/diy/audio/wav
fi
if [ -d $DIR_MOD_MISC ]; then
	echo "folder kernel module present"
	if diff $FILE_MODEXAMPLE upgrade/tmp/modexample.ko >/dev/null ; then
		echo "file match"
	else
		cp -f upgrade/tmp/modexample.ko $DIR_MOD_MISC
	fi
else
	mkdir $DIR_MOD_MISC
	cp -f upgrade/tmp/modexample.ko $DIR_MOD_MISC
fi
if [ -d $DIR_TVCC ]; then
	echo "folder tvcc present"
else
	mkdir $DIR_TVCC
fi
if [ -f $FILE_STARTUP ]; then
	echo "file startup.sh present"
	if diff $FILE_STARTUP upgrade/tmp/startup.sh >/dev/null ; then
		echo "file match"
	else
		cp -f upgrade/tmp/startup.sh /home/user
	fi
else
	cp -f upgrade/tmp/startup.sh /home/user
fi
if [ -d $DIR_DATA_CATALOG ]; then
	echo "folder data/catalog present"
else
	mkdir -p $DIR_DATA_CATALOG
fi
if [ -d $DIR_CUSTOM_AUDIO_WAV ]; then
	echo "folder custom/audio/wav present"
else
	mkdir -p $DIR_CUSTOM_AUDIO_WAV
fi
if [ -d $DIR_DATA_BRAND ]; then
	rm -r data/sil data/nice data/diy
	rm data/no_image.jpg
else
	echo "folder data/brand OK"
fi
if [ -d $DIR_CUSTOM_BRAND ]; then
	rm -r custom/sil custom/nice custom/diy
else
	echo "folder custom/brand OK"
fi
if [ -d $DIR_DOWNLOAD_CLOUD ]; then
	echo "folder download/cloud present"
else
	mkdir -p /home/user/new/download/cloud
fi
if [ -f $FILE_DHCPD_RESERVATIONS ]; then
	echo "file dhcpd-reservations.conf present"
else
	cp -f upgrade/tmp/dhcpd-reservations.conf /etc
fi
if [ -f $FILE_HS3_GPIO_MOD ]; then
	echo "file hs3_gpio_mod.ko present"
else
	cp -f upgrade/tmp/hs3_gpio_mod.ko $DIR_MOD_MISC
fi
if [ -f $FILE_WPA_CLI_WPS ]; then
	echo "file wpa_cli_wps present"
else
	cp upgrade/tmp/wpa_cli_wps /usr/local/bin
fi
if [ -f $FILE_WPA_PASSPHRASE_WPS ]; then
	echo "file wpa_passphrase_wps present"
else
	cp upgrade/tmp/wpa_passphrase_wps /usr/local/bin
fi
if [ -f $FILE_WPA_SUPPLICANT_WPS ]; then
	echo "file wpa_supplicant_wps present"
else
	cp upgrade/tmp/wpa_supplicant_wps /usr/local/bin
fi
if [ -f $FILE_SSH_44P1 ]; then
	echo "file wpa_supplicant_wps present"
else
	cp upgrade/tmp/ssh_44p1 /usr/bin
fi
if [ -f $FILE_SCREEN_402 ]; then
	echo "file screen present"
else
	cp upgrade/tmp/screen /usr/bin
	cp -f upgrade/tmp/startup.sh /home/user
	cp -f upgrade/tmp/libelf/* /usr/lib
fi
if [ -f $FILE_VER_CARRIER_SET ]; then
	echo "file ver_carrier_set.sh present"
else
	cp upgrade/tmp/ver_carrier_set.sh /home/user/new
	rm -f /home/user/new/ver_upd.sh
fi
### PPP Installation
if [ -f $FILE_PPPD ]; then
	echo "file pppd present"
else
	cp -f upgrade/tmp/pppd /sbin
	cp -f upgrade/tmp/chat /sbin
	cp -rf upgrade/tmp/ppp /etc
	cp -rf upgrade/tmp/ppp_kdrv/*.ko /lib/modules/3.0.35-2666-gbdde708/kernel/drivers/net
	cp -rf upgrade/tmp/ppp_kdrv/modules.* /lib/modules/3.0.35-2666-gbdde708
fi
if [ -f $FILE_PPP_IP_UP ]; then
	echo "folder ppp ready"
else
	cp -rf upgrade/tmp/ppp /etc
fi
if [ -f $FILE_MOD_NET_USB_ASIX ]; then
	echo "file asix.ko present"
else
	mkdir -p $DIR_MOD_NET_USB
	cp -rf upgrade/tmp/modules/drivers/net/usb/asix.ko $DIR_MOD_NET_USB
	cp -rf upgrade/tmp/modules/drivers/net/usb/usbnet.ko $DIR_MOD_NET_USB
	cp -rf upgrade/tmp/modules/modules.dep $DIR_MOD
	cp -rf upgrade/tmp/modules/modules.order $DIR_MOD
fi
### U-BLOX LILY-W1 Driver modules installation
if [ -f $FILE_U_BLOX_V00 ]; then
	echo "folder u-blox v00 ready"
else
	cp -rf upgrade/tmp/u-blox/lib/. /lib/.
fi
### Upgrade hostapd to version 2.10 U-BLOX LILY-W1 Driver compatible
if diff $FILE_HOSTAPD upgrade/tmp/hostapd_2_10/hostapd >/dev/null ; then
	echo "HOSTAPD OK"
else
	cp -f upgrade/tmp/hostapd_2_10/hostapd /usr/local/bin/.
	cp -f upgrade/tmp/hostapd_2_10/hostapd_cli /usr/local/bin/.
	cp -f upgrade/tmp/hostapd_2_10/libcrypto.so.1.1 /lib/.
	cp -f upgrade/tmp/hostapd_2_10/libnl.so.3 /lib/.
	cp -f upgrade/tmp/hostapd_2_10/libnl-genl.so.3 /lib/.
	cp -f upgrade/tmp/hostapd_2_10/libssl.so.1.1 /lib/.
fi
if diff $FILE_MLANUTL upgrade/tmp/mlanutl >/dev/null ; then
	echo "MLANUTL OK"
else
	cp -f upgrade/tmp/mlanutl /home/user/new/.
fi

sync

